package reflectDemo;
import java.lang.reflect.*;

public class ReflectDemo {
	public static void main(String[] args)throws Exception {
		String str1 = "abc";
		Class cls1 = str1.getClass();
		Class cls2 = String.class;
		Class cls3 = Class.forName("java.lang.String");
		System.out.println(cls1 == cls2);
		System.out.println(cls2 == cls3);
		
		System.out.println(cls1.isPrimitive());  //false
		System.out.println(int.class.isPrimitive());  //true
		System.out.println(int.class == Integer.class);  //false
		System.out.println(int.class == Integer.TYPE);  //true
		System.out.println(int[].class.isPrimitive());  //false
		System.out.println(int[].class.isArray());
		
		Constructor con = String.class.getConstructor(StringBuffer.class);
		String str2 = (String)con.newInstance(new StringBuffer ("abc"));
		System.out.println(str2.charAt(2));
		
		//Field
		ReflectPoint pt1 = new ReflectPoint();
		Field fieldY = pt1.getClass().getField("y");
		int i = (Integer)fieldY.get(pt1);
		System.out.println("i = "+i);
		Field fieldX = pt1.getClass().getDeclaredField("x");
		fieldX.setAccessible(true);
		System.out.println(fieldX.get(pt1));
		
		Method methedCharAt = String.class.getMethod("charAt", int.class);
		System.out.println(methedCharAt.invoke(str1, 2));
	}
}




















